import java.util.concurrent.*;

public class FutureAndCallableExample {

  public static void main(String[] args) 
  throws InterruptedException, ExecutionException {
  
    ExecutorService executorService = Executors.newSingleThreadExecutor();

    Callable<String> T2 = () -> {
      // Perform some computation
      System.out.println("T2: Entered Callable");
      Thread.sleep(10000);
      System.out.println("T2: Callable is done... about to return");
      return "Made in and returned from T2";
    };

    System.out.println("T1: Submitting Callable");
    Future<String> futT2 = executorService.submit(T2); // returns a future

    // This line executes immediately
    System.out.println("T1: Do something else while callable is getting executed");
    Thread.sleep(2000);
    System.out.println("T1: something else done, now lets check in on our T2");

    System.out.println("T1: Retrieve the result of the future");
    // Future.get() blocks until the result is available
    String result = futT2.get();  // might block and wait
    System.out.println(result);

    executorService.shutdown();
  }
}
