import java.util.concurrent.*;

public class FutureIsDoneExample {

  public static void main(String[] args) 
  throws InterruptedException, ExecutionException {
  
    ExecutorService executorService = Executors.newSingleThreadExecutor();

    System.out.println("T1: firing up T2 to make me some date on a promise");
    Future<String> T2fut = executorService.submit(() -> {
      System.out.println("T2: starting...");
      Thread.sleep(2000);
      System.out.println("T2: done!");
      return "Produced by and sent from T2";
    });

    while(!T2fut.isDone()) {
      System.out.println("T1: T2 task is still not done...");
      Thread.sleep(200);
    }

    System.out.println("T1: T2 task completed! Retrieving the result");
    String result = T2fut.get();
    System.out.println(result);

    executorService.shutdown();
} }
